package javax.annotation;

import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Retention;
import java.lang.annotation.ElementType;
import java.lang.annotation.Target;

@Target({ ElementType.TYPE, ElementType.FIELD, ElementType.METHOD })
@Retention(RetentionPolicy.RUNTIME)
public @interface Resource {
    public abstract String name() default "";
    
    public abstract String lookup() default "";
    
    public abstract Class<?> type() default Object.class;
    
    public abstract Resource.AuthenticationType authenticationType() default Resource.AuthenticationType.CONTAINER;
    
    public abstract boolean shareable() default true;
    
    public abstract String mappedName() default "";
    
    public abstract String description() default "";
    
    public enum AuthenticationType
    {
        CONTAINER, 
        APPLICATION;
    }
}
